/*
This is a Trend 2 Trend Expert.

Trend Change:
-Open Orders immediately upon Trend Change at Bid/Ask +/- x points above/below price.

Exit:
-All Opened Orders, will automatically be closed at next change trend.
-All Pending Orders (from previous trend change) will be cancelled.


*/

#property copyright   "2005-2014, MetaQuotes Software Corp."
#property link        "http://www.mql4.com"

input double Lots =1;
input int Entry_Points = 2;
input string            first                   = "===================== adaSwing settings: =====================";
input double Multiplier = 15.0;
input double Ticksize = 0.25;
input double ATR_Period  = 15.0;
extern double ATR_DIV = 2.0;
input string            second                   = "===================== AllAveragesv4.6 settings: =====================";
extern int Price_Type_LH = 2;
extern int Price_Type_HL = 3;
extern int MA_Method = 34;
extern double MA_Period= 14;

static int traded_this_bar; 
static int traded_this_bar_reup; 
static int traded_this_bar_redn; 

void OnTick(void)
{
int ticket,total,cnt;
total=OrdersTotal();
int FirstOrderType = 0;


/*--------MAIN ENTRY START--------*/
if ((iCustom(NULL,0,"adaClearSwing_AllAverages_v4.6_EA_v1.2",Multiplier,Ticksize,ATR_Period,ATR_DIV,Price_Type_LH,Price_Type_HL,MA_Method,MA_Period,  5,1) ==1))

{
ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,Ask+Entry_Points,3,0,0,"macd sample",16385,0,Green);
}

if ((iCustom(NULL,0,"adaClearSwing_AllAverages_v4.6_EA_v1.2",Multiplier,Ticksize,ATR_Period,ATR_DIV,Price_Type_LH,Price_Type_HL,MA_Method,MA_Period,  5,1) ==0))   


{
ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,Bid-Entry_Points,3,0,0,"macd sample",16385,0,Red);
}
/*--------MAIN ENTRY END--------*/


for(cnt = total - 1; cnt >= 0; cnt--)
{

//Select Orders
OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

//SELL
if ((iCustom(NULL,0,"adaClearSwing_AllAverages_v4.6_EA_v1.2",Multiplier,Ticksize,ATR_Period,ATR_DIV,Price_Type_LH,Price_Type_HL,MA_Method,MA_Period, 5,1) ==0))   

{
if (OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP)
{
OrderDelete(OrderTicket());
}

if (OrderType()==OP_BUY)
{
if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Entry_Points,OrderTakeProfit(),0,Green));
}


}

//BUY
if ((iCustom(NULL,0,"adaClearSwing_AllAverages_v4.6_EA_v1.2",Multiplier,Ticksize,ATR_Period,ATR_DIV,Price_Type_LH,Price_Type_HL,MA_Method,MA_Period,  5,1) ==1))


{
if (OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP)
{
OrderDelete(OrderTicket());
}

if (OrderType()==OP_SELL)
{
if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Entry_Points,OrderTakeProfit(),0,Green));
}

}

}


} ///End void OnTick(void)///