/*
vLog

*/

//Property

#property indicator_chart_window
#property indicator_buffers 10
#property indicator_color1 White
#property indicator_color2 clrDodgerBlue
#property indicator_color3 Red
#property indicator_color4 clrDodgerBlue
#property indicator_color5 Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//External Variables
double extern Multiplier = 35.0;
double extern Ticksize = 0.25;
extern double ATR_Period = 15.0;
extern double ATR_DIV = 2.0;
extern int Price_Type_LH = 2;
extern int Price_Type_HL = 3;
extern int MA_Method = 34;
extern double MA_Period= 14;

//Internal Variables

int Arrow_Displacement = 3;
double MA_Shift = 0;
bool Trend_Bool;
double Value;
double IsUpSwingBuffer[];
double UpSwingLineBuffer[];
double DownSwingLineBuffer[];
double Trend_Buffer_Up[];
double Trend_Buffer_Dn[];
double Trend[];
double Value_buffer[];
double lowestHigh_buffer[];
double highestLow_buffer[];
double Trend_Alert[];

double lowestHigh_Array ;
double highestLow_Array ;


//Init Initialization
int init() 
{
SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2,clrIvory);
SetIndexBuffer(0, IsUpSwingBuffer);
   
SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
SetIndexBuffer(1, UpSwingLineBuffer);
SetIndexLabel(1,"UpSwingLine");

SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
SetIndexBuffer(2, DownSwingLineBuffer);
SetIndexLabel(2,"DownSwingLine");

SetIndexBuffer(3, Trend_Buffer_Up);
SetIndexStyle(3,DRAW_ARROW,STYLE_SOLID);
SetIndexArrow(3,233);
SetIndexLabel(3,"Trend_Buff_Up");

SetIndexBuffer(4, Trend_Buffer_Dn);
SetIndexStyle(4,DRAW_ARROW,STYLE_SOLID);
SetIndexArrow(4,234);
SetIndexLabel(4,"Trend_Buff_Dn");

SetIndexBuffer(5, Trend);
SetIndexStyle(5, DRAW_NONE);
SetIndexLabel(5,"Trend");

SetIndexBuffer(6, Value_buffer);
SetIndexStyle(6, DRAW_NONE);
SetIndexLabel(6,"Value_buffer");

SetIndexBuffer(7, highestLow_buffer);
SetIndexStyle(7, DRAW_NONE);
SetIndexLabel(7,"highestLow_buffer");

SetIndexBuffer(8, lowestHigh_buffer);
SetIndexStyle(8, DRAW_NONE);
SetIndexLabel(8,"lowestHigh_buffer");

SetIndexBuffer(9, Trend_Alert);
SetIndexStyle(9, DRAW_NONE);
SetIndexLabel(9,"Trend_Alert");

SetIndexEmptyValue(1, 0.0);
SetIndexEmptyValue(2, 0.0);

Trend_Bool = ((Close[Bars-1]>=Open[Bars-1]) ? true : false);
Trend[Bars-1] = ((Close[Bars-1]>=Open[Bars-1]) ? 1 : 0); 
Value_buffer[Bars-1] = ((Close[Bars-1]>=Open[Bars-1]) ? Low[Bars-1] : High[Bars-1]);

return(0);

}

//START INIT START
int start() 
{
//Initialise Values at the very first historical bar
int start = 0;
int limit;
int counted_bars = IndicatorCounted();

// nothing else to do?
if(counted_bars < 0) 
return(-1);

// do not check repeated bars
limit = Bars - 1 - counted_bars;
  
// Check if ignore bar 0
start = 1;  

// Check the signal foreach bar from past to present
for(int i = limit; i >= start; i--)
{
Trend[i] = 2;
Trend_Alert[i] = Trend_Alert[i+1];

double atr = iATR (NULL, 0, ATR_Period, i) / ATR_DIV;

lowestHigh_buffer[i] = iCustom(NULL,0,"AllAverages_v4.6ea 600+",Price_Type_LH,MA_Period,MA_Method  ,0,i);
highestLow_buffer[i] =  iCustom(NULL,0,"AllAverages_v4.6ea 600+",Price_Type_HL,MA_Period,MA_Method  ,0,i);

lowestHigh_Array = lowestHigh_buffer[i];
highestLow_Array = highestLow_buffer[i];


if (Trend_Bool) 
{ 
double highestLow = MathMax(Value_buffer[i+1], highestLow_Array ); 

if (High[i] < highestLow - (Ticksize*Multiplier*atr)) 


{ 
Trend_Bool = false;
Value_buffer[i] = lowestHigh_Array;
Trend[i] = 0;
}

else
{
Trend_Bool = true;
Value_buffer[i] = highestLow;
}


} 

if (!Trend_Bool) 
{ 
double lowestHigh = MathMin(Value_buffer[i+1], lowestHigh_Array); 

if (Low[i] > lowestHigh + (Ticksize*Multiplier*atr)) 
{ 
Trend_Bool = true; 
Value_buffer[i] = highestLow_Array;
Trend[i] = 1; 
} 

else
{
Trend_Bool = false;
Value_buffer[i] = lowestHigh;
}

} 

if (Trend_Bool) 
{
IsUpSwingBuffer[i] = 1.0;
DownSwingLineBuffer[i] = 0.0;
UpSwingLineBuffer[i] = iMA(NULL,0,5,MA_Shift,MODE_SMMA,PRICE_LOW,i);
} 
else 
{
IsUpSwingBuffer[i] = 0.0;
UpSwingLineBuffer[i] = 0.0;
DownSwingLineBuffer[i] = iMA(NULL,0,5,MA_Shift,MODE_SMMA,PRICE_HIGH,i);
}

if (Trend[i] == 1 && Trend[i+1] ==2)
{
Trend_Buffer_Up[i] = Low[i]-atr*Arrow_Displacement;
Trend_Alert[i] = 1;
}

if (Trend[i] == 0 && Trend[i+1] ==2)
{
Trend_Buffer_Dn[i] = High[i]+atr*Arrow_Displacement;
Trend_Alert[i] =-1;


}


} 
return(0);

}
//END INIT START